/// <reference types="react" />
import 'twin.macro';
import { FilterValue, FilterMap } from '../types';
interface GridStateObject {
    stickyColumnName?: string;
    columnNames: string[];
    filteredData: any[];
    diffs: object[];
    filters: FilterMap<FilterValue>;
    sort: string[];
    schema?: object;
}
export interface GridProps {
    data: any[];
    diffData?: any[];
    metadata?: Record<string, string>;
    canDownload?: Boolean;
    defaultFilters?: FilterMap<FilterValue>;
    defaultSort?: string[];
    defaultStickyColumnName?: string;
    onChange?: (currentState: GridStateObject) => void;
    downloadFilename?: string;
    isEditable?: boolean;
    onEdit?: (newData: any[]) => void;
}
export declare function Grid(props: GridProps): JSX.Element;
export declare function encodeFilterString(filters?: Record<string, FilterValue>): string;
export {};
